c----------------------------------------------------------------------
c  for multi-timestep method for normal MD
c----------------------------------------------------------------------
      subroutine book_mlt(iall,istr_b,iend_b,iatm,iperiod,
     &nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,rtest,
     &nkind_m,nc_m,nbr_m,npbx_m,npby_m,npbz_m,nbrall_m,nbrp_m,
     &nbrmax_m,mltf,imltf,imltf2,rtest_m,mltn,mltfn,
     &cutdeg,xi,yi,zi,gmat)
c
c-------------------------------------------------------
c     transform the book 
c     original book --> book for multi-step verlet
c       nbr(*,*)         nbr_m(*,*)
c-------------------------------------------------------
c
      include 'para.inc'
      include 'set_kind.inc'
      dimension nkind(iall)
      dimension nbr(ncut,iall),nc(iall)
      dimension npbx(ncut,iall),npby(ncut,iall),npbz(ncut,iall)
      dimension nbrall(nbinfo,iall*ncut),nbrp(ncut,iall)
c
      dimension nkind_m(iall/nmlt)
      dimension nbr_m(ncut,iall/nmlt),nc_m(iall/nmlt)
      dimension npbx_m(ncut,iall/nmlt),npby_m(ncut,iall/nmlt),
     &                                       npbz_m(ncut,iall/nmlt)
      dimension nbrall_m(nbinfo,iall/nmlt*ncut),nbrp_m(ncut,iall/nmlt)
c
      dimension mltf(iall),imltf(iall),imltf2(iall)
      dimension rtest(iall*ncut)
      dimension rtest_m(iall/nmlt*ncut)
      dimension xi(iall),yi(iall),zi(iall)
      dimension gmat(3,3)
      dimension iatm(iregion)
c
c
c     mltn    : total number of moving atoms (H)
c     mltfn   : total number of atoms required for force calc.
c     mltf(i) : atomic numbers of atoms required for calc.
c
cccc initialized         
       mltn  = 0; mlt = 0 
       imltf = 0; imltf2 = 0
       mltfn = 0; mltf = 0; 
c
      mlt1:do i = 1,iall
cccc setting multi-step region
         if (nkind(i).eq.2) then   ! only hydrogen atoms are registrated
            mltn = mltn + 1
            mltf(mltn) = i
         endif
      enddo mlt1
c
c      write(6,*)mltn,mltf,istr_b,iend_b,istr_b2
c
      mltfn = mltn
c
ccccc create new book      
      do i = 1,mltn
         mapi  = mltf(i)
         imltf(mapi) = i
         imltf2(mapi) = 1
      enddo
c
      rcut2 = dbcut(2) + dbcut(1)*cutdeg
      rcut1 = dbcut(1) + dbcut(1)*cutdeg
      rcut = rcut1
c
      mlt2:do i = istr_b,iend_b      
      if (imltf2(i).eq.0) then
c
       find:do ifnd=1,mltn
       m_atm = mltf(ifnd)
       if ((iperiod.eq.1).or.(iperiod.eq.2)) then
ccccc for periodic boundary condition modified 2000-12-28
       rx0=xi(i)-xi(m_atm)
       rx1=xi(i)-xi(m_atm)+1.0d0
       rx2=xi(i)-xi(m_atm)-1.0d0
       sx0=(dsign(1.0d0,0.5d0-abs(rx0))+1)*0.5d0
       sx1=(dsign(1.0d0,0.5d0-abs(rx1))+1)*0.5d0
       sx2=(dsign(1.0d0,0.5d0-abs(rx2))+1)*0.5d0
c
       ry0=yi(i)-yi(m_atm)
       ry1=yi(i)-yi(m_atm)+1.0d0
       ry2=yi(i)-yi(m_atm)-1.0d0
       sy0=(dsign(1.0d0,0.5d0-abs(ry0))+1)*0.5d0
       sy1=(dsign(1.0d0,0.5d0-abs(ry1))+1)*0.5d0
       sy2=(dsign(1.0d0,0.5d0-abs(ry2))+1)*0.5d0
c
       rz0=zi(i)-zi(m_atm)
       rz1=zi(i)-zi(m_atm)+1.0d0
       rz2=zi(i)-zi(m_atm)-1.0d0
       sz0=(dsign(1.0d0,0.5d0-abs(rz0))+1)*0.5d0
       sz1=(dsign(1.0d0,0.5d0-abs(rz1))+1)*0.5d0
       sz2=(dsign(1.0d0,0.5d0-abs(rz2))+1)*0.5d0
c
       rxi=sx0*rx0+sx1*rx1+sx2*rx2
       ryi=sy0*ry0+sy1*ry1+sy2*ry2
       rzi=sz0*rz0+sz1*rz1+sz2*rz2
c
       else
ccccc for free boundary condition modified 2000-12-28
       rx0=xi(i)-xi(m_atm)
       ry0=yi(i)-yi(m_atm)
       rz0=zi(i)-zi(m_atm)
       rxi=rx0
       ryi=ry0
       rzi=rz0
       endif
c
       rr2=gmat(1,1)*rxi*rxi+gmat(2,1)*ryi*rxi+gmat(3,1)*rzi*rxi+
     &     gmat(1,2)*rxi*ryi+gmat(2,2)*ryi*ryi+gmat(3,2)*rzi*ryi+
     &     gmat(1,3)*rxi*rzi+gmat(2,3)*ryi*rzi+gmat(3,3)*rzi*rzi
c       rr2=gmat(1,1)*rxi*rxi+gmat(2,2)*ryi*ryi+gmat(3,3)*rzi*rzi
c
       rr  = sqrt(rr2)
c
       if (rr.lt.rcut) then
          mltfn = mltfn + 1
          mltf(mltfn) = i
          exit find
       endif
       enddo find
c
      endif !imltf2
      enddo mlt2
c
c for debug
c      write(98,*)mltn,mltfn
c      write(98,*)'[mltf ]',(mltf(i),i=1,mltfn)
c*      write(98,*)'[mltf2]',(mltf2(i),i=1,mltfn)
c
      iall5 = iall/nmlt
c      write(6,*)iall5,mltfn,mltn
      if (mltfn.gt.iall5) then 
      write(6,*)'book_mltr.f mltfn.gt.iall/nmlt'
      stop
      endif
c     
ccccc
      iall_m  = mltfn
      icls_m  = mltfn
      isub_m  = 0
c     
c
      do i = mltn+1,mltfn
         mapi  = mltf(i)
         imltf(mapi) = i
      enddo
c         
       nc_m = 0
c
ccc for debug
c*      write(98,*)'[imltf2]',(imltf2(i),i=1,iall)
c*      write(98,*)'[imltf ]',(imltf(i),i=1,iall)
c
      nbrmax_m = 0
      nc_m = 0
c
      out:do i_lc = 1,mltfn    ! i_lc --> i_local
         i_gl = mltf(i_lc) ! i_gl --> i_global
         nci  = nc(i_gl)
         nci_m = nc_m(i_lc)
         in:do jj = 1,nci
          j_gl = nbr(jj,i_gl)
          j_lc = imltf(j_gl)
          if ((j_lc.ne.0).and.(j_lc.gt.i_lc)) then
ccccc  i_lc - j_lc pair is in the mltf region                
             nbrpjj=nbrp(jj,i_gl)
             iold = nbrall(1,nbrpjj)
             jold = nbrall(2,nbrpjj)
             ncci = nbrall(3,nbrpjj)
             nccj = nbrall(4,nbrpjj)
             nbkind = nbrall(5,nbrpjj)   !modified
c             write(6,*)'---------------------'
c             write(6,*)i_lc,j_lc,i_gl,j_gl
c             write(6,*)iold,jold,ncci,nccj
             ncj_m = nc_m(j_lc)
             nci_m = nci_m + 1
             ncj_m = ncj_m + 1
             nbr_m(nci_m,i_lc) = j_lc
             nbr_m(ncj_m,j_lc) = i_lc
             nbrmax_m = nbrmax_m + 1
             nbrall_m(1,nbrmax_m) = i_lc
             nbrall_m(2,nbrmax_m) = j_lc
             nbrall_m(3,nbrmax_m) = nci_m
             nbrall_m(4,nbrmax_m) = ncj_m
c
             nbrall_m(5,nbrmax_m) = nbkind  !modified
c
             nbrp_m(nci_m,i_lc) = nbrmax_m
             nbrp_m(ncj_m,j_lc) = nbrmax_m
             if (iold.eq.i_gl) then
                nb_i = ncci
                nb_j = nccj
                if (jj.ne.ncci) stop 'jj.ne.ncci'
             else
                nb_j = ncci
                nb_i = nccj
                if (jj.ne.nccj) stop 'jj.ne.nccj'
             endif
             npbx_m(nci_m,i_lc) = npbx(nb_i,i_gl)
             npbx_m(ncj_m,j_lc) = npbx(nb_j,j_gl)
             npby_m(nci_m,i_lc) = npby(nb_i,i_gl)
             npby_m(ncj_m,j_lc) = npby(nb_j,j_gl)
             npbz_m(nci_m,i_lc) = npbz(nb_i,i_gl)
             npbz_m(ncj_m,j_lc) = npbz(nb_j,j_gl)
             nc_m(j_lc) = ncj_m
          endif
         enddo in
             nc_m(i_lc) = nci_m
      enddo out
c
      if (icode.ne.1) then
      open(79,file='nc_m.dat')
      out1:do i=1,iall_m
         jj=nc_m(i)
         out2:do j=1,jj
            npr=nbrp_m(j,i)
       write(79,'(1x,7i5)')
     & npr,i,nbr_m(j,i),npbx_m(j,i),npby_m(j,i),npbz_m(j,i),
     & jj
      enddo out2
      enddo out1
c
      out3:do i=1,iall_m
         jj=nc_m(i)
         out4:do j=1,jj
            npr=nbrp_m(j,i)
       iold = mltf(i)
       jold = mltf(nbr_m(j,i))
       write(79,'(1x,7i5)')
     & npr,iold,jold,npbx_m(j,i),npby_m(j,i),npbz_m(j,i),
     & jj
      enddo out4
      enddo out3
c
      endfile(79)
      close(79)
c     
      endif
c
      return
      end
