      program main
c--------------------------------------------------------
c   S.Izumi 2000-12-27 
c--------------------------------------------------------
      include 'para.inc'
      include 'poten.inc'
      include 'cell.inc'
      include 'set_kind.inc'  ! # of kind of atom and bond
c
      include 'atom.inc' ! atomic information
      include 'book.inc' ! for book-keeping method
      include 'multi_step.inc' ! for multi-step method
c
c**** file open
      character*70 f_number(ifile)
      integer index
      integer*4 k
      character*60 arg
      external getarg
      k=1
      call getarg ( k, arg )
      call fopen(arg,f_number,ifile,index)  ! all file open
cccc read from number.dat
      read(8,'(4e15.7)')dt,tff,wm,pex
      read(8,*)ntsteps,ntemp,nstat,nbstep,nout_out,nout_mon,nout_nc
      read(8,*)iall,ir_atms,ztop,cutdeg
      read(8,*)(iatm(i),i=1,ir_atms)
      read(8,*)(imov(i),i=1,ir_atms) ! 02-01-08
      read(8,*)(itemp(i),i=1,ir_atms) ! 02-01-08
      read(8,*)is_b,ie_b,iperiod ! 02-01-08
      read(8,*)multmeth,ifstr,ifconj
c
      iall0 = iall
      tf_sub=tff*Tch  ! non-dimensional temperature
ccccc added at  02-01-08 cccccccccccc
      istr = 1   
      iend = 0   
      do i = 1,ir_atms 
      tf(i) = tf_sub*float(itemp(i))
      iend = iend + iatm(i)*imov(i)
      enddo
      iatms=1
      do i = 1,ir_atms
         if (imov(i).eq.0) then
            iatms = i -1
            exit
         endif   
      enddo
ccccc added at  02-01-08 cccccccccccc end
c
      if (multmeth.eq.1) 
     &write(6,*)'---------------multi-time method--------------'
      if (multmeth.eq.0) 
     &write(6,*)'-------------normal MD---------------'
c
      ndim_out = ntsteps/nout_out
      ndim_mon = ntsteps/nout_mon + 1
      iall5 = iall / nmlt
c
      include 'atom_aloc.inc'
      include 'book_aloc.inc'
      include 'multi_step_aloc.inc'
c
      write(6,*)('-',i=1,35)   ! '-----------------'
      write(6,*)'total step=',ntsteps
      write(6,*)'time step=',dt
      write(6,*)'temparture=',tff
      write(6,*)'inverse of lattice weight=',wm
      write(6,*)'hydrostatic pressure=0',pex
      write(6,*)'scale temperature or not(0=No scaling,1=scaling)',ntemp
      write(6,*)'initial state(0) or continued state(1)',nstat
      write(6,*)'Book-making cut-off degree',cutdeg
      write(6,*)'Book-making renewal steps',nbstep
      write(6,*)'Animation interval steps',nout_out
      write(6,*)'Monitor interval steps',nout_mon
      write(6,*)'Interval steps of Book output',nout_nc
      write(6,*)'total number of atom',iall
      do i = 1,ir_atms
      write(6,*)' number of region',i,'=',iatm(i)
      enddo
ccccc added at  02-01-08 cccccccccccc 
      write(6,*)'Number of moving region (iatms)=',iatms
      write(6,*)'First and final atomic # of moving region'
     &,istr,iend
      write(6,*)'First and final atomic # of bulk region'
     &,is_b,ie_b
      write(6,*)'Temperature control Frag',(itemp(i),i=1,ir_atms)
ccccc added at  02-01-08 cccccccccccc end
c
      write(6,*)('-',i=1,35)   ! '-----------------'
ccccc error messages 
      if (ntemp.eq.0) write(6,*)'temperature is not scaled!!'
      if (ntemp.eq.1) write(6,*)'temperature is scaled!!'
      close(8)
c
c*** parameter initalized
      bug = epsilon(1.0d0)
      stress = 0.0d0;smat=0.0d0
      avr_at =0.0d0; avr_sc=0.0d0
      imon = 0; ioutxy = 0; ifc = 0  ! monitor,cotinue
      tnw=0.0d0; uk=0.0d0
      fx=0.0d0; fy=0.0d0; fz=0.0d0
      ddx2=0.0d0;ddy2=0.0d0;ddz2=0.0d0
      fx_m=0.0d0;fy_m=0.0d0;fz_m=0.0d0
      ddx2_m = 0.0d0; ddy2_m = 0.0d0; ddz2_m = 0.0d0
c
      nbr=0
ccc set the numbers
      call set_atom_bond
c
c-----------------------------------------------------------------
c  input data
c----------------------------------------------------------------
      call input(iall,nstat,nkind,iatm,
     &x,y,z,vx,vy,vz,xi,yi,zi,vxi,vyi,vzi,fx,fy,fz,ddx2,ddy2,ddz2,
     &wg,wginv,hmat,hmat0,hmati,vol,hmat0i,vol0)
c
c**** calculate various matrix
      call matcal(hmat,smat,hmati,hmatt,hmatti,gmat,gmati,
     &                  sigma,apst0,vol,vgmat,vhmat)
      call constant
c
ccc detect cutoff distance
      call set_cut
     &(multmeth,iall,nkind,tf_sub,dt,nbstep,bc_si,dmarg1,dmarg2,bcut_r,      
     &idel,istr_b,iend_b)      
c
      if (wm.ne.0.0d0)
     &call set_npt(iall,ddx1,ddy1,ddz1,stm1,stm2,smat,arg) 
c
      call energy
     &(iall,istr,iend,iatm,iatms,vx,vy,vz,wg,vij,ekin,tnw,uk)
c
      do i = 1,iatms
      write(6,*)'temperature of region',i,'=',tnw(i)/Tch
      enddo
c
       write(6,*)'start book-keeping......'
c
      if (ibalance.eq.1)  then
      call balance(iall,istr,iend,vx,vy,vz,vxi,vyi,vzi,hmat)
      write(6,*)'balance correction!!'   
      else
      write(6,*)'no balance correction!!'   
      endif
c
      idel = 0
      istr_b = 1; iend_b =iall
      call book_period
     &(idel,istr_b,iend_b,iall,ndivxn,ndivyn,ndivzn,ndivx,ndivy,ndivz,
     &nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,iddm,nbstep,nstep,
     &x,y,z,xi,yi,zi,vx,vy,vz,gmat,hmat,
     &rtest,rxi,ryi,rzi,rbook,cutdeg,dt,bc_si,dmarg1,dmarg2,bcut_r)

c
      write(6,*)'book-keeping OK!'
c
c     monitor of various values
      call monitor(iall,is_b,ie_b,iatm,iatms,stress,tnw,uk,outmon,
     &       nc,nbr,npbx,npby,npbz,nbrp,rtest,nstep,nout_nc,
     &       ndim_mon,imon,f_number(17))
c
      if (multmeth.eq.1) then
      call book_mlt(iall,istr_b,iend_b,iatm,iperiod,
     &nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,rtest,
     &nkind_m,nc_m,nbr_m,npbx_m,npby_m,npbz_m,nbrall_m,nbrp_m,
     &nbrmax_m,mltf,imltf,imltf2,rtest_m,mltn,mltfn,
     &cutdeg,xi,yi,zi,gmat)
      endif
c
	  ifconj=0
	  ifstr=0   ! stress calculation frag
c-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-
      if (ifconj.eq.0) then  !MD
c
      write(6,*)'Molecular Dynamics'
      write(6,*)'     start! '
c
      tot_step = 1.0d0/real(ntsteps)
c averaging interval
      navestep = ntsteps
c
      mainloop: do ii=1,ntsteps
c
      nstep=ii
c
c***   coordinate & velocity (including tersoff_h.f and press.f)
      if (multmeth.eq.1) then
c
      call verlet_mlt(ifstr,iall,istr,iend,
cccc for tersoff_h.f (same as verlet.f)
     &     nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
c     &     r,xr,yr,zr,f1,f1d,f1dd,af,bf,daf,dbf,elam2,fnij,
cccc for verlet_mlt.f (same as verlet.f)
     &     dt,ddx2,ddy2,ddz2,hmat,hmati,fx,fy,fz,dx,dy,dz,
     &     x,y,z,xi,yi,zi,vx,vy,vz,vxi,vyi,vzi,stress,vij,wginv,wg,
cccc for multistep
     &     nkind_m,nc_m,nbr_m,npbx_m,npby_m,npbz_m,nbrall_m,nbrp_m,
     &     nbrmax_m,mltf,imltf,imltf2,rtest_m,mltfn,mltn,
     &     ddx2_m,ddy2_m,ddz2_m,x_m,y_m,z_m,vx_m,vy_m,vz_m,
     &     xi_m,yi_m,zi_m,vxi_m,vyi_m,vzi_m,fx_m,fy_m,fz_m,
     &     dx_m,dy_m,dz_m,wginv_m)
c
         else
c
      if (wm.eq.0.0d0) then
      call verlet(ifstr,iall,istr,iend,
cccc for tersoff_h.f
     &  nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
cccc for verlet.f 
     &  dt,ddx2,ddy2,ddz2,hmat,hmati,fx,fy,fz,dx,dy,dz,
     &  x,y,z,xi,yi,zi,vx,vy,vz,vxi,vyi,vzi,stress,vij,wginv,wg,ekin)
      else
      call verlet_npt(ifstr,iall,istr,iend,
cccc for tersoff_h.f
     &     nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
c     &     r,xr,yr,zr,f1,f1d,f1dd,af,bf,daf,dbf,elam2,fnij,
cccc for verlet.f 
     &     dt,ddx2,ddy2,ddz2,hmat,hmati,fx,fy,fz,dx,dy,dz,
     &     x,y,z,xi,yi,zi,vx,vy,vz,vxi,vyi,vzi,stress,vij,wginv,wg,
cccc for verlet_npt.f 
     &     ddx1,ddy1,ddz1,smat,hmatt,hmatti,gmat,gmati,
     &     sigma,apst0,vol,vgmat,vhmat,stm1,stm2,hmat0,wm)
c      hmat1 = hmat1 + hmat(1,1)/float(ntsteps)
c      hmat2 = hmat2 + hmat(2,2)/float(ntsteps) 
c      hmat3 = hmat3 + hmat(3,3)/float(ntsteps)
c      if (nstep.eq.ntsteps) write(25,'(3e17.9)')hmat1,hmat2,hmat3
      endif
      endif
c
c***     energy
      call energy
     &(iall,istr,iend,iatm,iatms,vx,vy,vz,wg,vij,ekin,tnw,uk)
      if (ntemp.eq.1) call temp_adj(iall,iatm,iatms,itemp,
     & vx,vy,vz,vxi,vyi,vzi,hmat,tf,tnw)
c     averaging
      call average(
     & iall,iall0,is_b,ie_b,istr,iend,iatm,iatms,x,y,z,
     & avr_sc,avr_at,tnw,uk,vij,ekin,stress,navestep,nstep)
c
      call matcal(hmat,smat,hmati,hmatt,hmatti,gmat,gmati,
     &                  sigma,apst0,vol,vgmat,vhmat)
c
      if ( mod(nstep,nout_out).eq.0) then
c  for animation
      call out
     &(iall,iall0,istr,iend,ndim_out,nkind,ioutxy,x,y,z,outxy,
     & ekin,vij,nc)
      endif
c
      if ( mod(nstep,nout_mon).eq.0) then
c  monitor of various values
      call monitor(iall,is_b,ie_b,iatm,iatms,stress,tnw,uk,outmon,
     &       nc,nbr,npbx,npby,npbz,nbrp,rtest,nstep,nout_nc,
     &       ndim_mon,imon,f_number(17))
      endif
c      
c
      if (mod(nstep,nbstep).eq.0) then ! book
c
      if (ibalance.eq.1) 
     &call balance(iall,istr,iend,vx,vy,vz,vxi,vyi,vzi,hmat)
c
      idel = 0
      istr_b = 1; iend_b =iall
      call book_period
     &(idel,istr_b,iend_b,iall,ndivxn,ndivyn,ndivzn,ndivx,ndivy,ndivz,
     &nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,iddm,nbstep,nstep,
     &x,y,z,xi,yi,zi,vx,vy,vz,gmat,hmat,
     &rtest,rxi,ryi,rzi,rbook,cutdeg,dt,bc_si,dmarg1,dmarg2,bcut_r)
c
      if (multmeth.eq.1) then
      call book_mlt(iall,istr_b,iend_b,iatm,iperiod,
     &nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,rtest,
     &nkind_m,nc_m,nbr_m,npbx_m,npby_m,npbz_m,nbrall_m,nbrp_m,
     &nbrmax_m,mltf,imltf,imltf2,rtest_m,mltn,mltfn,
     &cutdeg,xi,yi,zi,gmat)
      endif
c
      endif
c
      enddo mainloop
c
      endif ! MD
c
c-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-MD-
c
      call fileout
     &(iall,iall0,iatms,ndim_mon,ndim_out,outmon,outxy,imon,ioutxy)
c
c-----------------------------------------------------------------
c  output data
c----------------------------------------------------------------
      call output(iall,istr,iend,nkind,
     & x,y,z,vx,vy,vz,fx,fy,fz,ddx2,ddy2,ddz2,hmat,hmat0)
c
          endfile(17); endfile(18); endfile(19);
c
          endfile(21); endfile(24); endfile(25); endfile(26)
          endfile(30); endfile(36); endfile(98); endfile(99)
c
          close(17); close(18); close(19)
          close(21); close(24); close(25); close(26)
          close(30); close(36); close(98); close(99)
c
       stop
       end
