#### Makefile for MD
#
PROG	= md_sih
VER	= 1.0
OS      = obj
F77	= fort
CFLAGS	=
LDFLAGS	=

OBJS	=			\
		$(OS)/main.o	\
		$(OS)/input.o	\
		$(OS)/output.o	\
		$(OS)/set_atom_bond.o	\
		$(OS)/set_cut.o	\
		$(OS)/set_npt.o	\
		$(OS)/fopen.o	\
		$(OS)/balance.o	\
		$(OS)/constant_h.o	\
		$(OS)/monitor.o	\
		$(OS)/temp_adj.o	\
		$(OS)/energy.o	\
		$(OS)/book_period.o	\
		$(OS)/book_mlt.o	\
		$(OS)/out.o	\
		$(OS)/verlet.o	\
		$(OS)/verlet_npt.o	\
		$(OS)/verlet_mlt.o	\
		$(OS)/press.o	\
		$(OS)/matcal.o	\
		$(OS)/fileout.o	\
		$(OS)/tersoff_sih.o	\
		$(OS)/average.o	

SRCS	=			\
		main.f		\
		input.f		\
		output.f		\
		set_atom_bond.f		\
		set_cut.f		\
		set_npt.f		\
		fopen.f		\
		balance.f	\
		constant_h.f	\
		monitor.f	\
		temp_adj.f	\
		energy.f	\
		book_period.f	\
		book_mlt.f	\
		out.f		\
		verlet.f	\
		verlet_npt.f	\
		verlet_mlt.f	\
		press.f		\
		matcal.f	\
		fileout.f		\
		average.f		\
		tersoff_sih.f
HDRS	=	para.inc		\
		poten.inc		\
		cell.inc		\
		set_kind.inc		\
		atom.inc		\
		multi_step.inc		\
		book.inc		\
		atom_aloc.inc		\
		multi_step_aloc.inc	\
		book_aloc.inc

$(PROG):	$(OBJS)
		$(F77) $(LDFLAGS) $(OBJS) $(LIBS) -o $(PROG)

clean:
		rm -f $(PROG)
		rm -f $(OBJS)

$(OS)/main.o:		$(HDRS)         main.f  
			$(F77) $(CFLAGS) -c  -o $@ main.f  
$(OS)/input.o:		$(HDRS)         input.f  
			$(F77) $(CFLAGS) -c  -o $@ input.f  
$(OS)/output.o:		$(HDRS)         output.f  
			$(F77) $(CFLAGS) -c  -o $@ output.f  
$(OS)/set_atom_bond.o:	$(HDRS)         set_atom_bond.f  
			$(F77) $(CFLAGS) -c  -o $@ set_atom_bond.f  
$(OS)/set_cut.o:	$(HDRS)         set_cut.f  
			$(F77) $(CFLAGS) -c  -o $@ set_cut.f  
$(OS)/set_npt.o:	$(HDRS)         set_npt.f  
			$(F77) $(CFLAGS) -c  -o $@ set_npt.f  
$(OS)/fopen.o:		$(HDRS)         fopen.f  
			$(F77) $(CFLAGS) -c  -o $@ fopen.f  
$(OS)/balance.o:	$(HDRS)         balance.f  
			$(F77) $(CFLAGS) -c  -o $@ balance.f  
$(OS)/constant_h.o:	$(HDRS)         constant_h.f                 
			$(F77) $(CFLAGS) -c  -o $@ constant_h.f 
$(OS)/monitor.o:	$(HDRS)        	monitor.f  
			$(F77) $(CFLAGS) -c  -o $@	monitor.f  
$(OS)/energy.o: 	$(HDRS)        	energy.f   
			$(F77) $(CFLAGS) -c  -o $@	energy.f   
$(OS)/temp_adj.o: 	$(HDRS)        	temp_adj.f   
			$(F77) $(CFLAGS) -c  -o $@	temp_adj.f   
$(OS)/book_period.o: 	$(HDRS)         book_period.f                  
			$(F77) $(CFLAGS) -c  -o $@	book_period.f   
$(OS)/book_mlt.o: 	$(HDRS)         book_mlt.f                  
			$(F77) $(CFLAGS) -c  -o $@	book_mlt.f   
$(OS)/out.o:    	$(HDRS)         out.f                     
			$(F77) $(CFLAGS) -c  -o $@	out.f      
$(OS)/verlet_mlt.o: 	$(HDRS)         verlet_mlt.f                  
			$(F77) $(CFLAGS) -c  -o $@	verlet_mlt.f   
$(OS)/verlet.o: 	$(HDRS)         verlet.f                  
			$(F77) $(CFLAGS) -c  -o $@	verlet.f   
$(OS)/verlet_npt.o: 	$(HDRS)         verlet_npt.f                  
			$(F77) $(CFLAGS) -c  -o $@	verlet_npt.f   
$(OS)/press.o:  	$(HDRS)        	press.f    
			$(F77) $(CFLAGS) -c  -o $@	press.f    
$(OS)/matcal.o: 	$(HDRS)        	matcal.f   
			$(F77) $(CFLAGS) -c  -o $@	matcal.f   
$(OS)/fileout.o: 	$(HDRS)        	fileout.f   
			$(F77) $(CFLAGS) -c  -o $@	fileout.f   
$(OS)/tersoff_sih.o:	$(HDRS)        	tersoff_sih.f  
			$(F77) $(CFLAGS) -c  -o $@	tersoff_sih.f
$(OS)/average.o:	$(HDRS)        	average.f  
			$(F77) $(CFLAGS) -c  -o $@	average.f
