C-----------------------------------------------------------
C  Empirical interatomic potential for Si-H
C-----------------------------------------------------------
      subroutine calc_force(ifstr,iall,istr,iend,
     &           nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
     &           x,y,z,fx,fy,fz,hmat,stress,vij)
c
      include 'para.inc'
      include 'poten.inc'
c neighbors' information
      dimension nbrall(nbinfo,iall*ncut),nbrp(ncut,iall)
      dimension nbr(ncut,iall),nc(iall)
c neighbors boundary condition
      dimension npbx(ncut,iall),npby(ncut,iall),npbz(ncut,iall) 
c kind of atom ( 1:Si , 2:H , 3:C )
      dimension nkind(iall)
c atomic coordinates
      dimension x(iall),y(iall),z(iall)
c atomic force
      dimension fx(iall),fy(iall),fz(iall)
      dimension hmat(3,3),stress(6,iall)
c atomic potential energy
      dimension vij(iall)
c      
cccc local variables
      dimension costh(np8),gdcos(np8),gth(np8),rnm(np8),expr(np8)
      dimension gdm(np8),rnrm(np8),betm(np8),alpm(np8),cctd(np8)
      dimension rmk(np8),f1m(np8),f1dm(np8),f1ddm(np8),
     &          xrmk(np8),yrmk(np8),zrmk(np8)
      dimension r(6*iall),xr(6*iall),yr(6*iall),zr(6*iall),
     &          f1(6*iall),f1d(6*iall),f1dd(6*iall)
      dimension af(6*iall),bf(6*iall),daf(6*iall),dbf(6*iall),
     &          elam2(6*iall)
cccc for f1_bnd , f2_bnd 
c*** fnij(1,i) : Number of Si-neighboors of atom i
c*** fnij(2,i) : Number of  H-neighboors of atom i
c*** fnij(3,i) : Number of  C-neighboors of atom i 
c*** fnij(4,i) : Number of    neighboors of atom i 
c                                 = fnij(1,i)+fnij(2,i)+fnij(3,i)
      dimension fnij(4,iall)
c*****reset variables
      fx=0.0d0; fy=0.0d0; fz=0.0d0
      vij= 0.0d0;fnij=0.0d0; stress=0.0d0
c
c***** the part of 2-body forces which is independent of coordinate number
c          ###Vij=Vji
      twoatm:do kkk=1,nbrmax
c
        i =nbrall(1,kkk)
        j =nbrall(2,kkk)
        jj=nbrall(3,kkk)
        kbnd=nbrall(5,kkk)
c
        nnc=nc(i)
        xii=x(i)
        yii=y(i)
        zii=z(i)
c
c******only (j > i) calculation 
         if (j.gt.i) then
c
           npr=nbrp(jj,i)
c
           pbx = float(npbx(jj,i))
           pby = float(npby(jj,i))
           pbz = float(npbz(jj,i))
           rx=x(j)-xii+hmat(1,1)*pbx+hmat(1,2)*pby+hmat(1,3)*pbz
           ry=y(j)-yii+hmat(2,1)*pbx+hmat(2,2)*pby+hmat(2,3)*pbz
           rz=z(j)-zii+hmat(3,1)*pbx+hmat(3,2)*pby+hmat(3,3)*pbz
c
            rd2=rx*rx+ry*ry+rz*rz
c    rd = rij
            rd=dsqrt(rd2)
            r(npr)=rd
c
            rninv=1.0d0/rd
c
            xr(npr)=rx*rninv
            yr(npr)=ry*rninv
            zr(npr)=rz*rninv
c
            rxn=rx
            ryn=ry
            rzn=rz
c     
          nk1 = nkind(i)
          nk2 = nkind(j)
c
          cutr = dcutr(kbnd)
          cutd = dcutd(kbnd)
c
cccc  set cutoff distance !!
            cut = cutr + cutd
            cut2= cutr - cutd
c
            pai2=pai/2.0d0
            dns1=(dsign(1.0d0,cut-rd)+1.0d0)*0.5d0
            dns2=(dsign(1.0d0,rd-cut2)+1.0d0)*0.5d0
            sind=dsin(pai*0.5d0*(rd-cutr)/cutd)
            cosd=dcos(pai*0.5d0*(rd-cutr)/cutd)
            sind3=dsin(pai*1.5d0*(rd-cutr)/cutd)
            cosd3=dcos(pai*1.5d0*(rd-cutr)/cutd)
c     cutoff function fc(rij) & fc'(rij)
      f1(npr)=(0.5d0-0.5625d0*sind-0.0625d0*sind3)*dns2*dns1+
     &  1.0d0-dns2
      f1d(npr)=(-0.28125d0*pai/cutd*cosd -
     &  0.09375d0*pai/cutd*cosd3)*dns2*dns1
      f1dd(npr)=(0.140625d0*pai*pai/cutd/cutd*sind +
     &  0.140625d0*pai*pai/cutd/cutd*sind3)*dns2*dns1
c
      if (f1(npr).lt.0.0d0) then
       f1(npr)=0.0d0; f1d(npr)=0.0d0; f1dd(npr)=0.0d0
      endif
cccc for Si-H-C system
	fnij(nk2,i) = fnij(nk2,i) + f1(npr)
	fnij(nk1,j) = fnij(nk1,j) + f1(npr)
cccc total Nt_ij
	fnij(4,i) = fnij(4,i) + f1(npr)
	fnij(4,j) = fnij(4,j) + f1(npr)
c
          a1   = da1(kbnd)
          b2   = db2(kbnd)
          amd1 = damd1(kbnd)
          amd2 = damd2(kbnd)
c
      elam1=a1*dexp(-amd1*rd)
      elam2(npr)=b2*dexp(-amd2*rd)
ccccc Vab=af(npr)-bf(npr)*bij
      af(npr)=f1(npr)*elam1
      bf(npr)=f1(npr)*elam2(npr)
ccccc daf=daf/dra , dbf=dbf/dra
      daf(npr)=elam1*f1d(npr)-amd1*af(npr)
      dbf(npr)=elam2(npr)*f1d(npr)-amd2*bf(npr)
c
      endif
      enddo twoatm
c
c******remaining part of potentials and forces which depends
c       upon environment(3-body forces)
c
        iatom:do i=istr,iall
         nnc=nc(i)
cccc kind of atom
         nk1 = nkind(i)
cccc coordination number of Si
c      fn_hi = fn_h(i)
c      fn_sii= fn_si(i)
c      fn_tot = fn_hi + fn_sii
c
		fsi1 = (nk1-2)*(nk1-3)/2.0 
		fn_tot = fnij(4,i)*fsi1
c
         if (nnc.eq.0) cycle iatom  ! modified 
c
         jatom:do jj=1,nnc  ! modified
c *******  The jj-th  neighborhood of atom i is atom j
            j=nbr(jj,i)
c
            nsn=sign(1,j-i)
            npr=nbrp(jj,i)
            kbnd = nbrall(5,npr)
c
ccccc cutoff
            f1npr=f1(npr)
            if (f1npr.le.0.0d0) cycle jatom ! modified
            f1dnpr=f1d(npr)
            f1ddnpr=f1dd(npr)
c
            xrn=float(nsn)*xr(npr)
            yrn=float(nsn)*yr(npr)
            zrn=float(nsn)*zr(npr)
c
            rn=r(npr)
c
            rxn=xrn*rn
            ryn=yrn*rn
            rzn=zrn*rn
c
            rninv=1.0d0/rn
c
            afnpr=af(npr)
            bfnpr=bf(npr)
            dafnpr=daf(npr)
            dbfnpr=dbf(npr)
            elam2npr=elam2(npr)
c
cccc kind of atom(j)
            nk2 = nkind(j)
            fsi2 = (nk2-2)*(nk2-3)/2.0   ! added at 2001-3-20
            fn_tot2 = fnij(4,j)*fsi2  ! added at 2001-3-20
c
cccc------------------------------------------------------------
cccc   Spline and setting values of F1(N),F2(N) --> f1_bnd,f2_bnd
cccc   modified at 01-3-20  Only Si-H bonding
         call fspln(f1_bnd,f2_bnd,fn_tot,fn_tot2,nk1,nk2)   
c
        vij(i) = vij(i) + afnpr/4.0*f1_bnd
        vij(j) = vij(j) + afnpr/4.0*f1_bnd
c
      ffx=dafnpr*xrn/2.0d0*f1_bnd
      fx(i)=fx(i)+ffx
      fx(j)=fx(j)-ffx
c
      ffy=dafnpr*yrn/2.0d0*f1_bnd
      fy(i)=fy(i)+ffy
      fy(j)=fy(j)-ffy
c
      ffz=dafnpr*zrn/2.0d0*f1_bnd
      fz(i)=fz(i)+ffz
      fz(j)=fz(j)-ffz
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      if (ifstr.eq.0)
     & call calc_st(stress,rxn,ryn,rzn,ffx,ffy,ffz,i,j,iall)
c
      reqn = dreq(kbnd)
      enu  = denu(kbnd)
      enu2 = denu2(kbnd)
c
      zeta=0.0d0
c
      if (nnc.ne.1) then ! modified (if 3)
c
      katom1:do kk=1,nnc  ! modified 
         k=nbr(kk,i)
c
        if(k.eq.j) cycle katom1  ! modified 
c
            nsm=sign(1,k-i)
            mpr=nbrp(kk,i)
c
            kbnd2 = nbrall(5,mpr)  ! kind of i-k bond
cccc cut-off
            f1m(kk)=f1(mpr)
            if (f1m(kk).le.0.0d0) cycle katom1 ! modified 
            f1dm(kk)=f1d(mpr)
            f1ddm(kk)=f1dd(mpr)
c
            xrm=float(nsm)*xr(mpr)
            yrm=float(nsm)*yr(mpr)
            zrm=float(nsm)*zr(mpr)
c
       rm=r(mpr)
c
       xrmk(kk)=xrm
       yrmk(kk)=yrm
       zrmk(kk)=zrm
       rmk(kk)=rm
c
      nk3 = nkind(k)
cc cos(abc)
      costh(kk)=xrn*xrm+yrn*yrm+zrn*zrm
ccc Spline and setting values of H(N) or h
      call fspgh(gh,fn_tot,nk1,nk2,nk3)
ccc setting c,d
      call bparam3(gc,gc_ss,gc_sh1,gc_sh2,gc_hh,nk1,nk2,nk3)
      call bparam3(gd,gd_ss,gd_sh1,gd_sh2,gd_hh,nk1,nk2,nk3)
c
      gdm(kk) = gd
      gdcos(kk)=gh - costh(kk)
cc g(theta)
      gth(kk)=gc + gd * gdcos(kk)*gdcos(kk)
ccc dg(theta)/dcosth = cctd(kk)
      cctd(kk) = - 2.0d0 * gd * gdcos(kk)
cc r_ab - r_ac
      rnm(kk)=rn-rm
      rnm2=rnm(kk)*rnm(kk)
cc a part of zeta (exp-term)
ccc setting alpha,beta
      call bparam3(alp,alp_ss,alp_sh1,alp_sh2,alp_hh,nk1,nk2,nk3)
ccc test version !!
c      alp =0.0d0
      call bparam3(bet,bet_ss,bet_sh1,bet_sh2,bet_hh,nk1,nk2,nk3)
ccc setting R^e(ik)
      reqm = dreq(kbnd2)
c
      alpm(kk) = alp
      betm(kk) = bet
cc (r_{ab} -r^e_{ab}) - (r_{ac} - r^e_{ac})
      rnrm(kk) = (rn-reqn) - (rm-reqm) 
      ibet = int(bet)
c
      exprpp = rnrm(kk)**ibet
c
      if (exprpp.gt.100.0d0)  then
         write(99,*)'exprpp error ( exprpp.gt.100)'
         stop
      else
         expr(kk)=dexp(alp * exprpp)
      endif
c
      ztest=f1m(kk)*gth(kk)*expr(kk)
cc zeta
      zeta=zeta+f1m(kk)*gth(kk)*expr(kk)

      enddo katom1
      endif ! (if 3)
c
      if (zeta .lt. bug) then
c      write(99,*)'(zeta.lt.bug) in tersoff_h.f'
c      write(99,*)'zeta=',i,j,zeta
      bzn=0.0d0
      else
c     A part of bij
      bzn=zeta**enu
c
      endif
c
c      write(6,*)'zeta=',i,j,zeta
c      write(6,*)'bzn=',bzn
c
      if (i_mi.eq.1) then
      if (kbnd.eq.1) then
       fss_i  = fnij(4,i) -1 ! Number of i neighbor
       fss_j  = fnij(4,j) -1 ! Number of j neighbor
       fss_ij = fnij(2,i) +  fnij(2,j) ! Number of H
       call fssfunc(fss,fss_i,fss_j,fss_ij)
c       fss=0.0d0  ! test
       else
       fss = 0.0d0
       endif
       else
       fss = 0.0d0 
       endif
c
cc bij
      bij=(1.0d0+bzn)**(-enu2)
      bij_bar = bij + fss*0.5d0
c
      vij(i) = vij(i) - bfnpr*bij_bar*f2_bnd/2.0d0
      vij(j) = vij(j) - bfnpr*bij_bar*f2_bnd/2.0d0
c
      ff=dbfnpr*bij_bar*f2_bnd
c
      ffx=ff*xrn
c
      fx(i)=fx(i)-ffx
      fx(j)=fx(j)+ffx
c
      ffy=ff*yrn
      fy(i)=fy(i)-ffy
      fy(j)=fy(j)+ffy
c
      ffz=ff*zrn
      fz(i)=fz(i)-ffz
      fz(j)=fz(j)+ffz
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      rxnm = -rxn
      rynm = -ryn
      rznm = -rzn
c
      if (ifstr.eq.0)
     & call calc_st(stress,rxnm,rynm,rznm,ffx,ffy,ffz,i,j,iall)
c
      if ((nnc.eq.1).or.(zeta .lt. bug)) cycle iatom ! modified
cc a part of db/dz
      z2n=(1.0d0+bzn)*zeta
cc db/dz
      bz=-bij*bzn*enu*enu2/z2n
cc dv/dz *F2(N) = dv/db*db/dz *F2(N) 
cc                           : dv/db = -bfnpr(vab=af(npr)-bf(npr)bij)
      vzab=bfnpr*bij*bzn*enu*enu2/z2n*f2_bnd
c
      katom2:do kk=1,nnc ! modified
         k=nbr(kk,i)
c
         if (k.eq.j) cycle katom2 ! modified 
            f1mpr=f1m(kk)
         if (f1mpr.le.0.0d0) cycle katom2 ! modified
            f1dmpr=f1dm(kk)
            f1ddmpr=f1ddm(kk)
c  r_aci/r_ac
            xrm=xrmk(kk)
            yrm=yrmk(kk)
            zrm=zrmk(kk)
c r_ac
            rm=rmk(kk)
c r_aci 
            rxm=xrm*rm
            rym=yrm*rm
            rzm=zrm*rm
            rminv=1.0d0/rm
c r_bci
            rxp=rxm-rxn
            ryp=rym-ryn
            rzp=rzm-rzn
c r_bc
            rp=sqrt(rxp*rxp+ryp*ryp+rzp*rzp) !heavy
            rpinv=1.0d0/rp
c r_bci/r_bc 
            xrp=rxp*rpinv
            yrp=ryp*rpinv
            zrp=rzp*rpinv
c
            costhkk=costh(kk)
            gthkk=gth(kk)
            rnmkk=rnm(kk)
            rnm2kk=rnmkk*rnmkk
            gdcoskk=gdcos(kk)
            exprkk=expr(kk)
            gdmkk = gdm(kk)
            rnrmkk=rnrm(kk)
            betmkk=betm(kk)
            alpmkk=alpm(kk)
            cctdkk=cctd(kk)
c
      rminv=1.0d0/rm
      ibetmkk = int(betmkk-1.0d0)
      fglr_1 = rnrmkk**ibetmkk
c
cc alpha*beta*{c+d(H-costh)^2}{(rab-R^e(ab))-(rac-R^e(ac))}^(beta-1)
      fglr=alpmkk*betmkk*gthkk*fglr_1
c
cc a part of dz/dcos
cc dv/dz*fc(rac)*exp[alpha*{(rab-R^e(ab))-(rac-R^e(ac))}^beta]
      f=vzab*f1mpr*exprkk
c
c  dv/dz*dz/dr_{ab}
      ff=f*fglr
c
      ffx=ff*xrn
c
      fx(i)=fx(i)+ffx
      fx(j)=fx(j)-ffx
c
      ffy=ff*yrn
      fy(i)=fy(i)+ffy
      fy(j)=fy(j)-ffy
c
      ffz=ff*zrn
      fz(i)=fz(i)+ffz
      fz(j)=fz(j)-ffz
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      if (ifstr.eq.0)
     &   call calc_st(stress,rxn,ryn,rzn,ffx,ffy,ffz,i,j,iall)
c
cc dv/dz*dz/dr_{ac}
cc dv/dz*dfc(rac)/dr(ac)*{c+d(H-costh)^2}}*
cc       exp[alpha*{(rab-R^e(ab))-(rac-R^e(ac))}^beta] - ff
       ff2=vzab*f1dmpr*gthkk*exprkk-ff
c
      ffx=ff2*xrm
c
      fx(i)=fx(i)+ffx
      fx(k)=fx(k)-ffx
c
      ffy=ff2*yrm
      fy(i)=fy(i)+ffy
      fy(k)=fy(k)-ffy
c
      ffz=ff2*zrm
      fz(i)=fz(i)+ffz
      fz(k)=fz(k)-ffz
c
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      if (ifstr.eq.0)
     & call calc_st(stress,rxm,rym,rzm,ffx,ffy,ffz,i,k,iall)
c
cc dz/dcos = dfc(rac)/dr(ac) * 
cc   exp[alpha*{(rab-R^e(ab))-(rac-R^e(ac))}^beta]*dg(theta)/dcosth
cc                dg/dcos = - 2.0*d*(H-costh) (=cctdkk)
      zcos=f1mpr*exprkk*cctdkk
cc dv/dz*dz/dcos
      ff3=vzab * zcos
c
cc dcos/dra
      cosra=-costhkk*rninv+rminv
cc dcos/drc
      cosrc=-costhkk*rminv+rninv
cc dcos/dr_bc
      cosrb=-rp*rninv*rminv
c
cc r_ab
      ffx=ff3*cosra*xrn
      fx(i)=fx(i)+ffx
      fx(j)=fx(j)-ffx
      ffy=ff3*cosra*yrn
      fy(i)=fy(i)+ffy
      fy(j)=fy(j)-ffy
      ffz=ff3*cosra*zrn
      fz(i)=fz(i)+ffz
      fz(j)=fz(j)-ffz
c
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      if (ifstr.eq.0)
     & call calc_st(stress,rxn,ryn,rzn,ffx,ffy,ffz,i,j,iall)
cc r_{ac}
      ffx=ff3*cosrc*xrm
      fx(i)=fx(i)+ffx
      fx(k)=fx(k)-ffx
      ffy=ff3*cosrc*yrm
      fy(i)=fy(i)+ffy
      fy(k)=fy(k)-ffy
      ffz=ff3*cosrc*zrm
      fz(i)=fz(i)+ffz
      fz(k)=fz(k)-ffz
c
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      if (ifstr.eq.0)
     & call calc_st(stress,rxm,rym,rzm,ffx,ffy,ffz,i,k,iall)
cc r_{bc}
      ffx=ff3*cosrb*xrp
      fx(j)=fx(j)+ffx
      fx(k)=fx(k)-ffx
      ffy=ff3*cosrb*yrp
      fy(j)=fy(j)+ffy
      fy(k)=fy(k)-ffy
      ffz=ff3*cosrb*zrp
      fz(j)=fz(j)+ffz
      fz(k)=fz(k)-ffz
c
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      if (ifstr.eq.0)
     & call calc_st(stress,rxp,ryp,rzp,ffx,ffy,ffz,j,k,iall)
c
      enddo katom2
      enddo jatom
      enddo iatom
c
      return      
      end

      subroutine calc_st(stress,rxn,ryn,rzn,ffx,ffy,ffz,i,j,iall)
ccc for stress tensor(11->1, 22->2, 33->3, 23->4, 13->5, 12->6)
      include 'para.inc'
      dimension stress(6,iall)
      v1 = rxn*ffx/2.0
      stress(1,i)=stress(1,i)-v1
      stress(1,j)=stress(1,j)-v1
      v2 = ryn*ffy/2.0
      stress(2,i)=stress(2,i)-v2
      stress(2,j)=stress(2,j)-v2
      v3 = rzn*ffz/2.0
      stress(3,i)=stress(3,i)-v3
      stress(3,j)=stress(3,j)-v3
      v6 = ryn*ffx/2.0
      stress(6,i)=stress(6,i)-v6
      stress(6,j)=stress(6,j)-v6
      v5 = rzn*ffx/2.0
      stress(5,i)=stress(5,i)-v5
      stress(5,j)=stress(5,j)-v5
      v4 = rzn*ffy/2.0
      stress(4,i)=stress(4,i)-v4
      stress(4,j)=stress(4,j)-v4
      return
      end
c
cccc   modified at 01-3-20
      subroutine fspln(f1_bnd,f2_bnd,fn_tot,fn_tot2,nk1,nk2)
      include 'para.inc'
      include 'set_kind.inc'
c
c
c***************************************
cc   nk1(i)   nk2(j)   par
cc     1        1       F1=1.0,F2=1.0
cc     1        2       F1=F1(fn_tot),F2=F2(fn_tot)
cc     2        1       F1=F1(fn_tot2),F2=F2(fn_tot2)  ! modified
cc     2        2       F1=1.0,F2=1.0
c***************************************
c
cc----IF sentence version -----------------------------------------
      f1_bnd=1.0d0;f2_bnd=1.0d0
      kbnd = npairbond(nk1,nk2)
      if (kbnd.eq.2) then
         if (nk1.eq.1) call f12bnd(fn_tot ,f1_bnd,f2_bnd)
         if (nk2.eq.1) call f12bnd(fn_tot2,f1_bnd,f2_bnd)
      endif
c
       return
       end
c
      subroutine f12bnd(fn_tot,fff1,fff2)
      include 'para.inc'
      dimension c1(3,3),y1(4)
      dimension c2(3,3),y2(4)
	  if (i_mi.eq.0) then
ccccc Marty
      C1(1,1) =  0.3883333E+00
      C1(1,2) = -0.3413111E+00
      C1(1,3) =  0.5697778E-01
      C1(2,1) = -0.1233556E+00
      C1(2,2) = -0.1703778E+00
      C1(2,3) =  0.1377333E+00
      C1(3,1) = -0.5091111E-01
      C1(3,2) =  0.2428222E+00
      C1(3,3) = -0.1449111E+00
ccccc Marty
      C2(1,1) =  0.3323333E+00
      C2(1,2) = -0.2712444E+00
      C2(1,3) =  0.4391111E-01
      C2(2,1) = -0.7842222E-01  
      C2(2,2) = -0.1395111E+00
      C2(2,3) =  0.1169333E+00 
      C2(3,1) = -0.6644444E-02
      C2(3,2) =  0.2112889E+00
      C2(3,3) = -0.1386444E+00
cccc Marty
      y1(1)=1.005d0
      y1(2)=1.109d0
      y1(3)=0.953d0
      y1(4)=1.000d0
      y2(1)=0.93d0
      y2(2)=1.035d0
      y2(3)=0.934d0
      y2(4)=1.000d0
      endif
c
	  if (i_mi.eq.1) then
      C1(1,1) = 0.2283218E+00
      C1(1,2) =-0.2591617E+00
      C1(1,3) = 0.4455701E-01
      C1(2,1) =-0.1563307E+00
      C1(2,2) =-0.1254907E+00
      C1(2,3) = 0.1269632E+00
      C1(3,1) =-0.2642234E-01
      C1(3,2) = 0.2553990E+00
      C1(3,3) =-0.1614586E+00
      C2(1,1) =  0.1821046E+00
      C2(1,2) = -0.1754509E+00
      C2(1,3) =  0.2846188E-01 
      C2(2,1) = -0.8341144E-01
      C2(2,2) = -0.9006522E-01
      C2(2,3) =  0.9654840E-01
      C2(3,1) =  0.2610333E-01 
      C2(3,2) =  0.1995800E+00
      C2(3,3) = -0.1417544E+00
      y1(1)=0.1073623E+01 
      y1(2)=0.1087340E+01
      y1(3)=0.9324819E+00
      y1(4)=1.000d0
      y2(1)= 0.9578837E+00
      y2(2)= 0.9929994E+00
      y2(3)= 0.9160711E+00 
      y2(4)= 0.1000000E+01
      endif
c
      xx = fn_tot
c
cccc  p1 = 1 (xx < 2.0) ,p1 = 1 (xx > 2.0) 
         p1 = (dsign(1.0d0,2.0d0-xx)+1.0d0)/2.0d0
cccc  p3 = 1 (xx > 3.0) ,p3 = 0 (xx < 3.0) 
         p3 = (dsign(1.0d0,xx-3.0d0)+1.0d0)/2.0d0
cccc  p2 = 1 ( 2.0 < xx < 3.0) ,p2 = 0 (else)
         p2 = 1.0d0 - p1 - p3
cccc  p4 = 1 (xx > 4.0) ,p4 = 0 (xx < 4.0) 
         p4 = (dsign(1.0d0,xx-4.0d0)+1.0d0)/2.0d0
c
         p0 =  p1*1.0d0 + p2*2.0d0 + p3*3.0d0
         nsp = int( p0 )
         v1s = xx - p0
c
       ff1 = y1(nsp) + v1s * (C1(nsp,1) + v1s * 
     &      (C1(nsp,2) + v1s * C1(nsp,3)))
       ff2 = y2(nsp) + v1s * (c2(nsp,1) + v1s * 
     &      (c2(nsp,2) + v1s * c2(nsp,3)))
c
       fff1 = ff1*(1.0d0 - p4) + y1(4)*p4
       fff2 = ff2*(1.0d0 - p4) + y2(4)*p4
c
       return
       end
c
      subroutine fspgh(gh,fn_tot,nk1,nk2,nk3)
c
      include 'para.inc'
      include 'poten.inc'
c
c      gh_ss  = -0.59826d0  ! Si-Si-Si
c      gh_sh2 = -1.0d0      ! H-Si-Si
c      gh_hh  =  0.0d0      ! H-H-H
c
cc----IF sentence version -----------------------------------------
c***************************************
cc   nk1(i)   nk2(j)   nk3(k)   par
cc     1        1        1       1
cc     1        1        2       2a
cc     1        2        1       2a
cc     1        2        2       2a
cc     2        1        1       2b(or 3)
cc     2        1        2       3
cc     2        2        1       3
cc     2        2        2       3
c***************************************
c
      if (nk1.eq.1) then
         if (nk2.eq.1) then
            if (nk3.eq.1) gh=gh_ss    ! Si-Si-Si
            if (nk3.eq.2) then
               call f3bnd(fn_tot,gh)  ! Si-Si-H
            endif
         else
               call f3bnd(fn_tot,gh)  ! Si-H-Si, Si-H-H            
         endif
      else
         if (nk2.eq.1) then
cc For bond-centerd H interstitial ccccccccccccccccccccccccc
            if (nk3.eq.1) gh=gh_hh    ! H-Si-Si
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            if (nk3.eq.2) gh=gh_hh    ! H-Si-H
         else
            if (nk3.eq.1) gh=gh_hh    ! H-H-Si
            if (nk3.eq.2) gh=gh_hh    ! H-H-H
         endif
      endif
c
       return
       end
c
      subroutine f3bnd(fn_tot,f3_bnd)
      include 'para.inc'
      dimension c3(3,3),y3(4)
c
	  if (i_mi.eq.0) then
ccccc Marty
      C3(1,1) =  0.2106667E+00
      C3(1,2) = -0.2623556E+00
      C3(1,3) =  0.5168889E-01
      C3(2,1) = -0.1589778E+00
      C3(2,2) = -0.1072889E+00 
      C3(2,3) =  0.3026667E-01
      C3(3,1) = -0.2827556E+00 
      C3(3,2) = -0.1648889E-01 
      C3(3,3) =  0.1052444E+00
ccccc Marty
      y3(1)=-0.04d0
      y3(2)=-0.04d0
      y3(3)=-0.276d0
      y3(4)=-0.470d0
      endif
c
      if (i_mi.eq.1) then
      C3(1,1) =  0.3328467E+00
      C3(1,2) = -0.4088524E+00
      C3(1,3) =  0.7600572E-01
      C3(2,1) = -0.2568410E+00
      C3(2,2) = -0.1808353E+00
      C3(2,3) =  0.1214146E+00
      C3(3,1) = -0.2542676E+00 
      C3(3,2) =  0.1834087E+00
      C3(3,3) = -0.3751659E-01
c
      y3(1)=-0.4536291E-01
      y3(2)=-0.4536291E-01
      y3(3)= -0.3616245E+00 
      y3(4)=-0.470d0
      endif
c
      xx = fn_tot
c
cccc  p1 = 1 (xx < 2.0) ,p1 = 1 (xx > 2.0) 
c         p1 = (dsign(1.0,2.0-xx)+1.0)/2.0
         p1 = (dsign(1.0d0,2.0d0-xx)+1.0d0)/2.0d0
cccc  p3 = 1 (xx > 3.0) ,p3 = 0 (xx < 3.0) 
c         p3 = (dsign(1.0,xx-3.0)+1.0)/2.0
         p3 = (dsign(1.0d0,xx-3.0d0)+1.0d0)/2.0d0
cccc  p2 = 1 ( 2.0 < xx < 3.0) ,p2 = 0 (else)
         p2 = 1.0d0 - p1 - p3
cccc  p4 = 1 (xx > 4.0) ,p4 = 0 (xx < 4.0) 
c         p4 = (dsign(1.0,xx-4.0)+1.0)/2.0
         p4 = (dsign(1.0d0,xx-4.0d0)+1.0d0)/2.0d0
c
         p0 =  p1*1.0d0 + p2*2.0d0 + p3*3.0d0
         nsp = int( p0 )
         v1s = xx - p0
c
       ff3 = y3(nsp) + v1s * (C3(nsp,1) + v1s * 
     &      (C3(nsp,2) + v1s * C3(nsp,3)))
c
       f3_bnd = ff3*(1.0d0 - p4) + y3(4)*p4
c
       return
       end
c
      subroutine bparam3(bpar,par_ss,par_sh1,par_sh2,par_hh,nk1,nk2,nk3)
c
      include 'para.inc'
      dimension par(2,2,2)
c
c***************************************
cc   nk1(i)   nk2(j)   nk3(k)   par
cc     1        1        1       1
cc     1        1        2       2a ???
cc     1        2        1       2a
cc     1        2        2       2a
cc     2        1        1       2b(or 3)
cc     2        1        2       3
cc     2        2        1       3
cc     2        2        2       3
c***************************************
c
cc----IF sentence version -----------------------------------------
      if (nk1.eq.1) then
         if (nk2.eq.1) then
            if (nk3.eq.1) bpar=par_ss   ! 1-1-1
            if (nk3.eq.2) bpar=par_sh1  ! 1-1-2
         else
            if (nk3.eq.1) bpar=par_sh1  ! 1-2-1
            if (nk3.eq.2) bpar=par_sh1  ! 1-2-2
         endif
      else
         if (nk2.eq.1) then
c For bond-centerd H interstitial ccccccccccccccccc
           if (nk3.eq.1) bpar=par_sh2      ! bond-centered version
c
            if (nk3.eq.2) bpar=par_hh  ! 2-1-2
      else
            if (nk3.eq.1) bpar=par_hh  ! 2-2-1
            if (nk3.eq.2) bpar=par_hh  ! 2-2-2
         endif
      endif
cc----------------------------------------------------------------
          return
          end
c
      subroutine fssfunc(fss,fss_i,fss_j,fss_ij)
      include 'para.inc'
      dimension c1(4,3),y1(5)
c
c     fss_i  ... # of neighbor of atom i
c     fss_j  ... # of neighbor of atom j
c     fss_ij = fnij(2,i) +  fnij(2,j) !
c                             Number of H sticking in Si-Si bond
c
ccccc fss_ij direction spline
      C1(1,1) = 0.0000000E+00; C1(1,2) = 0.9175714E+00
      C1(1,3) =-0.5655714E+00; C1(2,1) = 0.1384286E+00
      C1(2,2) =-0.7791429E+00; C1(2,3) = 0.3887143E+00
      C1(3,1) =-0.2537143E+00; C1(3,2) = 0.3870000E+00
      C1(3,3) =-0.1332857E+00; C1(4,1) = 0.1204286E+00
      C1(4,2) =-0.1285714E-01; C1(4,3) =-0.3157143E-01
c
      y1(1)=0.0d0;y1(2)=0.352d0;y1(3)=0.10d0;y1(4)=0.10d0;y1(5)=0.176d0
c
      xx = fss_ij + 1.0d0
      nnx = int(xx)
c      p5 = (sign(1.0,xx-5.0)+1.0)/2.0
c
      v1 = xx - float(nnx)
c
      ff1 = y1(nnx) + v1 * 
     &(C1(nnx,1) + v1 * (C1(nnx,2) + v1 * C1(nnx,3)))
c
c      fss = ff1*(1.0 - p5) + y1(5)*p5
ccccc fss_i direction function
      xabs = abs(fss_i - 2.0d0); 
      yabs = abs(fss_j - 2.0d0); 
      fx_sp = (dcos(pai*xabs*2.0d0)+1.0d0)/2.0d0
      fy_sp = (dcos(pai*yabs*2.0d0)+1.0d0)/2.0d0
      if (xabs.gt.0.5d0) fx_sp=0.0d0
      if (yabs.gt.0.5d0) fy_sp=0.0d0
ccc original
c      xabs = abs(fss_i - 2.0d0); fx_sp = (dcos(pai*xabs)+1.0d0)/2.0d0
c      yabs = abs(fss_j - 2.0d0); fy_sp = (dcos(pai*yabs)+1.0d0)/2.0d0
c      if (xabs.gt.1.0d0) fx_sp=0.0d0
c      if (yabs.gt.1.0d0) fy_sp=0.0d0
ccc original
c
      fss = ff1*fx_sp*fy_sp
c
      return
      end
