      subroutine verlet(ifstr,iall,istr,iend,
cccc for calc_force.f
     &  nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
cccc for verlet.f 
     &  dt,ddx2,ddy2,ddz2,hmat,hmati,fx,fy,fz,dx,dy,dz,
     &  x,y,z,xi,yi,zi,vx,vy,vz,vxi,vyi,vzi,stress,vij,wginv,wg,ekin)
c
      include 'para.inc'
      include 'set_kind.inc'
c neighbors' information
      dimension nbrall(nbinfo,iall*ncut),nbrp(ncut,iall)
      dimension nbr(ncut,iall),nc(iall)
c neighbors boundary condition
      dimension npbx(ncut,iall),npby(ncut,iall),npbz(ncut,iall) 
c kind of atom ( 1:Si , 2:H , 3:C )
      dimension nkind(iall)
c
      dimension ddx2(iall),ddy2(iall),ddz2(iall)
      dimension hmat(3,3),hmati(3,3),stress(6,iall)
c atomic potential energy
      dimension vij(iall)
c atomic coordinates
      dimension x(iall),y(iall),z(iall)
c atomic velocity
      dimension vx(iall),vy(iall),vz(iall)
c image coordinate
      dimension xi(iall),yi(iall),zi(iall)
c image velocity
      dimension vxi(iall),vyi(iall),vzi(iall)
c atomic force
      dimension fx(iall),fy(iall),fz(iall)
ccc atomic weight
      dimension wginv(iall),wg(iall)
cccc  local variables
      dimension dx(iall),dy(iall),dz(iall)
ccccc for constrain
      dimension contx(iall),conty(iall),contz(iall)
      dimension ekin(iall)
c
      dt2=dt/2.0d0
c
ccccccc
c  atomic coordination ( avoiding the lost of keta)
      do i=istr,iend
         dx(i)=vxi(i)+dt2*ddx2(i)
         dy(i)=vyi(i)+dt2*ddy2(i)
         dz(i)=vzi(i)+dt2*ddz2(i)
      enddo
c------------------------------------------------
      do i=istr,iend
         xi(i)=xi(i)+dx(i)*dt
         yi(i)=yi(i)+dy(i)*dt
         zi(i)=zi(i)+dz(i)*dt
      enddo
c------------------------------------------------
c  partial velocity
      do i=istr,iend
        vxi(i)=dx(i)
        vyi(i)=dy(i)
        vzi(i)=dz(i)
      enddo
c------------------------------------------------
      do i=istr,iend
         x(i)=hmat(1,1)*xi(i)+hmat(1,2)*yi(i)+hmat(1,3)*zi(i)
         y(i)=hmat(2,1)*xi(i)+hmat(2,2)*yi(i)+hmat(2,3)*zi(i)
         z(i)=hmat(3,1)*xi(i)+hmat(3,2)*yi(i)+hmat(3,3)*zi(i)
      enddo
c
         call calc_force(ifstr,iall,istr,iend,
     &           nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
     &           x,y,z,fx,fy,fz,hmat,stress,vij)
c
         if (ifstr.eq.0) 
     &   call press(iall,istr,iend,nkind,vx,vy,vz,stress,hmat,wg)
c
      do 190 i=istr,iend
      wg_i = wginv(i)
      ddx2(i)=(hmati(1,1)*fx(i)+hmati(1,2)*fy(i)+hmati(1,3)*fz(i))*wg_i
      ddy2(i)=(hmati(2,1)*fx(i)+hmati(2,2)*fy(i)+hmati(2,3)*fz(i))*wg_i
      ddz2(i)=(hmati(3,1)*fx(i)+hmati(3,2)*fy(i)+hmati(3,3)*fz(i))*wg_i
 190   continue
c
c------------------------------------------------
c  velocity
      do 280 i=istr,iend
        vxi(i)=vxi(i)+dt2*ddx2(i)
        vyi(i)=vyi(i)+dt2*ddy2(i)
        vzi(i)=vzi(i)+dt2*ddz2(i)
 280   continue
c
c-----------------------------------------------------
      do i=istr,iend
      vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
      vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
      vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      return
      end





