c*********verlet algorithm for (HPN) method
      subroutine verlet_npt(ifstr,iall,istr,iend,
cccc for tersoff_h.f
     &     nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
c     &     r,xr,yr,zr,f1,f1d,f1dd,af,bf,daf,dbf,elam2,fnij,
cccc for verlet.f 
     &     dt,ddx2,ddy2,ddz2,hmat,hmati,fx,fy,fz,dx,dy,dz,
     &     x,y,z,xi,yi,zi,vx,vy,vz,vxi,vyi,vzi,stress,vij,wginv,wg,
cccc for verlet_npt.f 
     &     ddx1,ddy1,ddz1,smat,hmatt,hmatti,gmat,gmati,
     &     sigma,apst0,vol,vgmat,vhmat,stm1,stm2,hmat0,wm)
      include 'para.inc'
c
c neighbors' information
      dimension nbrall(nbinfo,iall*ncut),nbrp(ncut,iall)
      dimension nbr(ncut,iall),nc(iall)
c neighbors boundary condition
      dimension npbx(ncut,iall),npby(ncut,iall),npbz(ncut,iall) 
c kind of atom ( 1:Si , 2:H , 3:C )
      dimension nkind(iall)
c
      dimension ddx2(iall),ddy2(iall),ddz2(iall)
      dimension hmat(3,3),hmati(3,3),stress(6,iall)
c atomic potential energy
      dimension vij(iall)
c atomic coordinates
      dimension x(iall),y(iall),z(iall)
c atomic velocity
      dimension vx(iall),vy(iall),vz(iall)
c image coordinate
      dimension xi(iall),yi(iall),zi(iall)
c image velocity
      dimension vxi(iall),vyi(iall),vzi(iall)
c atomic force
      dimension fx(iall),fy(iall),fz(iall)
c
ccc atomic weight
      dimension wginv(iall),wg(iall)
ccc for NPT method
      dimension ddx1(iall),ddy1(iall),ddz1(iall)
      dimension vhmat(3,3),vgmat(3,3)
      dimension smat(3,3),gmati(3,3),sigma(3,3),apst0(3,3)
      dimension hmatt(3,3),hmatti(3,3),gmat(3,3)
      dimension stm1(3,3),stm2(3,3),hmat0(3,3)
cccc  local variables
      dimension dx(iall),dy(iall),dz(iall)
      dimension dh(3,3)
      dimension ggmat1(3,3)
      dimension stm3(3,3)
c
c  wm : mass of wall
c
      dt2=dt/2.0d0
c
      do  j=1,3
      do  i=1,3
         dh(i,j)=vhmat(i,j)+wm*dt2*(stm1(i,j)-stm2(i,j))
         hmat(i,j)=hmat(i,j)+dh(i,j)*dt
         vhmat(i,j)=dh(i,j)
      enddo
      enddo
cccc constrain shear deformation
       hmat(1,2)=0.0d0;hmat(1,3)=0.0d0;hmat(2,1)=0.0d0
       hmat(2,3)=0.0d0;hmat(3,1)=0.0d0;hmat(3,2)=0.0d0
       vhmat(1,2)=0.0d0;vhmat(1,3)=0.0d0;vhmat(2,1)=0.0d0
       vhmat(2,3)=0.0d0;vhmat(3,1)=0.0d0;vhmat(3,2)=0.0d0
c
      do i=istr,iend
         dx(i)=vxi(i)+dt2*(ddx2(i)-ddx1(i))
         dy(i)=vyi(i)+dt2*(ddy2(i)-ddy1(i))
         dz(i)=vzi(i)+dt2*(ddz2(i)-ddz1(i))
      enddo
c
      do i=istr,iend
         xi(i)=xi(i)+dx(i)*dt
         yi(i)=yi(i)+dy(i)*dt
         zi(i)=zi(i)+dz(i)*dt
         vxi(i)=dx(i)
         vyi(i)=dy(i)
         vzi(i)=dz(i)
      enddo
c
      do i=istr,iend
         x(i)=hmat(1,1)*xi(i)+hmat(1,2)*yi(i)+hmat(1,3)*zi(i)
         y(i)=hmat(2,1)*xi(i)+hmat(2,2)*yi(i)+hmat(2,3)*zi(i)
         z(i)=hmat(3,1)*xi(i)+hmat(3,2)*yi(i)+hmat(3,3)*zi(i)
c
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      call matcal(hmat,smat,hmati,hmatt,hmatti,gmat,gmati,
     &                  sigma,apst0,vol,vgmat,vhmat)
c
      call calc_force(ifstr,iall,istr,iend,
     &           nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
     &           x,y,z,fx,fy,fz,hmat,stress,vij)
c
         if (ifstr.eq.0) 
     &   call press(iall,istr,iend,nkind,vx,vy,vz,stress,hmat,wg)
c
      waru = 1.0d0/float(iall)
      stm3=0.0d0
      do i = istr,iend
       stm3(1,1) = stm3(1,1) + stress(1,i)*waru
       stm3(2,2) = stm3(2,2) + stress(2,i)*waru
       stm3(3,3) = stm3(3,3) + stress(3,i)*waru
       stm3(1,2) = stm3(1,2) + stress(6,i)*waru
       stm3(1,3) = stm3(1,3) + stress(5,i)*waru
       stm3(2,3) = stm3(2,3) + stress(4,i)*waru
      enddo
c
      stm3(2,1)=stm3(1,2); stm3(3,1)=stm3(1,3); stm3(3,2)=stm3(2,3)
c
      do j=1,3
      do i=1,3
         ggmat1(j,i)=gmati(j,1)*vgmat(1,i)+gmati(j,2)*vgmat(2,i)
     &+gmati(j,3)*vgmat(3,i)   ! G^{-1}dG/dt
      enddo
      enddo
c
      do i=istr,iend
      wg_i = wginv(i)
      ddx1(i)=ggmat1(1,1)*vxi(i)+ggmat1(1,2)*vyi(i)
     &        +ggmat1(1,3)*vzi(i)
      ddy1(i)=ggmat1(2,1)*vxi(i)+ggmat1(2,2)*vyi(i)
     &        +ggmat1(2,3)*vzi(i)
      ddz1(i)=ggmat1(3,1)*vxi(i)+ggmat1(3,2)*vyi(i)
     &        +ggmat1(3,3)*vzi(i)    ! G^{-1}dG/dt d(rho)/dt
cccc h^{-1}F/m
      ddx2(i)=(hmati(1,1)*fx(i)+hmati(1,2)*fy(i)+hmati(1,3)*fz(i))*wg_i
      ddy2(i)=(hmati(2,1)*fx(i)+hmati(2,2)*fy(i)+hmati(2,3)*fz(i))*wg_i
      ddz2(i)=(hmati(3,1)*fx(i)+hmati(3,2)*fy(i)+hmati(3,3)*fz(i))*wg_i
      enddo
c
ccccc  Cauchy * V * h^{-t}
      do j=1,3
      do i=1,3
       stm1(j,i)=  stm3(j,1)*sigma(1,i)+ stm3(j,2)*sigma(2,i)
     &              +stm3(j,3)*sigma(3,i)
       stm2(j,i)=  hmat(j,1)*apst0(1,i)+ hmat(j,2)*apst0(2,i)
     &              +hmat(j,3)*apst0(3,i)
      enddo
      enddo
c
ccccc  h * \Sigma
      do j=1,3
      do i=1,3
         vhmat(i,j)=vhmat(i,j)+wm*dt2*(stm1(i,j)-stm2(i,j))
      enddo
      enddo
c
      do i=istr,iend
        vxi(i)=vxi(i)+dt2*(ddx2(i)-ddx1(i))
        vyi(i)=vyi(i)+dt2*(ddy2(i)-ddy1(i))
        vzi(i)=vzi(i)+dt2*(ddz2(i)-ddz1(i))
      enddo
c
      do i=istr,iend
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      return
      end
